unit uPregame;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ActnList, ScktComp, Spin, ColorGrd,
  FileCtrl;

type
  Tpregame = class(TForm)
    bStart: TBitBtn; // Spousti hru
    bClient: TButton; // Pripojuje/odpojuje klienta
    bServer: TButton; // Vytvari/rusi server
    log: TMemo; // Zobrazuje hracum informace o hre
    sClient: TClientSocket;
    sServer: TServerSocket;
    eName: TLabeledEdit; // Obsahuje jmeno hrace
    eAddress: TLabeledEdit; // Obsahuje IP serveru
    eChat: TEdit; // Nabizi moznost poslat
    bChat: TButton; // ostatnim uzivatelum zpravu
    chrono: TTimer; // Herni casovac
    logframe: TGroupBox;
    cDialog: TColorDialog; // Vyber barvy letounu
    sColor: TShape;
    lColor: TLabel;
    bEnd: TButton; // Ukonci hru
    seWin: TSpinEdit; // Nastavuje podminky vitezstvi
    lWin: TLabel;
    cbGameType: TComboBox; // Vyber modu hry
    lTeamColor: TLabel; // Vyber barvy tymu
    cColor: TColorBox;
    bShow: TButton; // Zobrazi herni okno
    chatframe: TGroupBox;
    chat: TMemo; // Zobrazuje rozhovor hracu
    cbSnd: TCheckBox; // Prepina zvuk
    listMap: TFileListBox; // Zobrazuje dostupne mapy
    lMap: TLabel;
    procedure clientconnect; // Proces pripojeni klienta
    procedure clientdisconnect; // Proces odpojeni klienta
    procedure addclientable; // Vytvori a rozesle seznam hracu
    procedure addshotable; // Vytvori a rozesle seznam informaci o strelach
    procedure addteamtable; // Vytvori a rozesle hrajicich tymu
    procedure addcubetable; // Vytvori a rozesle informaci o kostkach
    procedure reactual; // Aktualizuje nastaveni hrace
    procedure restore; // Obnovi nastaveni po ukonceni hry
    procedure newgame; // Resetuje nastaveni hry na jejim zacatku
    function distance(x1,y1,z1,x2,y2,z2:double):double; // Vzdalenost dvou bodu
    procedure getmessage(var textus:string); // Dekoduje prijatou zpravu
    procedure bExitClick(Sender: TObject); // Opusteni hry
    procedure bMinimizeClick(Sender: TObject); // Minimalizace
    procedure bStartClick(Sender: TObject); // Spusteni hry
    procedure bServerClick(Sender: TObject); // Spusteni / vypnuti serveru
    procedure sServerClientRead(Sender: TObject; Socket: TCustomWinSocket);
      // Prijem informaci serverem po siti
    procedure sClientRead(Sender: TObject; Socket: TCustomWinSocket);
      // Prijem informaci po siti
    procedure bClientClick(Sender: TObject); // Spusteni klienta
    procedure bChatClick(Sender: TObject); // Odeslani zpravy hracum
    procedure chronoTimer(Sender: TObject); // Procedura casovace
    procedure sColorMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer); // Vyber barvy
    procedure bEndClick(Sender: TObject); // Opusteni hry
    procedure seWinChange(Sender: TObject); // Nastaveni podminek vitezstvi
    procedure cbGameTypeChange(Sender: TObject); // Zmena typu hry
    procedure cColorChange(Sender: TObject); // Zmena barvy tymu
    procedure bShowClick(Sender: TObject); // Zobrazeni hry
    procedure eNameEnter(Sender: TObject); // Spusteni serveru
    procedure eAddressEnter(Sender: TObject); // Spusteni klienta
    procedure eChatChange(Sender: TObject);
    procedure listMapChange(Sender: TObject); // Vyber mapy
    procedure FormCreate(Sender: TObject); // Po spusteni programu
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  pregame: Tpregame; // Formular nastaveni pred hrou
  winumber,gametype:integer; // Mod a podminka hry
  clientid:integer; // Nahodne generovane ID klienta
  datatext,textosend:string; // Data posilana po siti
  ingame:boolean; // Spustenost hry
  radarzoom,shspeed0,shspeed1:double;
    // Zvetseni radaru, rychlost strely a rakety
  cucnt,shcnt,shptr,playercnt:integer;
    // Pocet krychli, aktualni strela, pocet strel, hracu
  ks,ls,ms,
  kps,lps,mps,
  angs,angrs,anghs,
  inlongs
  :array[1..32] of double; // Pozice, rychlost, rotace souperu, zobrazovanost
  carrys:array[1..32] of integer; // Cislo nesene krychle
  winid:integer; // ID viteze
  winname:string; // Jmeno viteze
  teamcolor:array[1..20] of TColor; // Barva tymu
  teamid:integer; // ID meho tymu
  clientsid:array[1..32] of integer; // ID hracu
  clientsname:array[1..32] of string; // Jmena hracu
  clientscolor,clientstcolor:array[1..32] of TColor; // (Tymova) barva hracu
  cux,cuy,cuz,
  cuxb,cuyb,cuzb,
  cuax,cuay,cuaz
  :array[1..20] of double; // Pozice krychle (aktualni, zakladni), rotace
  cuowner:array[1..20] of integer; // Vlastnik krychle
  shx,shy,shz,
  shxp,shyp,shzp,
  shax,shay,shaz
  :array[1..16384] of double; // Pozice, rychlost, rotace strely
  shs,sht,showner:array[1..16384] of integer; // Druh, cil, vlastnik strely
  shact:array[1..16384] of boolean; // Aktivita strely
  quitsoon,cleanresp:boolean;
  quithowsoon,view:integer;
    // Ukoncovaci priznaky
  mapname,teamtext:string; // Nazev souboru mapy, vypis tymu

implementation

uses uUniverse;

{$R *.dfm}


procedure Tpregame.bClientClick(Sender: TObject);
begin
bClient.Default:=false;
if bClient.Caption='Join' then
begin
  // Nastavovani GUI
cbGameType.Enabled:=false;
seWin.Enabled:=false;
listMap.Enabled:=false;
listMap.Font.Color:=clMedGray;
bClient.Caption:='Leave';
bServer.enabled:=false;
clientconnect; // Pripojeni
end else clientdisconnect; // Odpojeni
end;

procedure Tpregame.clientconnect;
var i:integer;
temp:string;
begin
  // Reset
winid:=0;frags:=0;hits:=0;
  // Nastaveni GUI
eAddress.Enabled:=false;
eName.Enabled:=false;
temp:=eName.Text;
  // Nahrazeni ridicich znaku ve jmene
for i:=1 to length(temp) do if temp[i]='#' then temp[i]:='*';
eName.Text:=temp;
if eName.Text='' then eName.Text:='Ridiculous Anonymous';
  // Pripojeni
sClient.Port:=3201;
sClient.Address:=eAddress.Text;
application.ProcessMessages;
sClient.Open;
application.ProcessMessages;
sleep(500);
application.ProcessMessages;
sClient.Socket.SendText('chg'+inttostr(clientid)+eName.Text+'`'
+ColorToString(sColor.Brush.Color)+'`'
+ColorToString(cColor.Selected)+'#');
if ingame then begin //Pripad, ze uz je hra spustena
sleep(500);
application.ProcessMessages;
universe.show;
end;
end;

procedure Tpregame.clientdisconnect;
begin
sClient.Socket.SendText('dis'+inttostr(clientid)+eName.Text+'#');
  // Upozorneni serveru na odpojeni
application.ProcessMessages;
sClient.Close; // Odpojeni
ingame:=false; universe.Hide;
restore;
  // Obnoveni GUI
end;

procedure Tpregame.newgame;
begin
  // Reset pred hrou
shcnt:=0;shptr:=1;
ingame:=false;
bShow.Enabled:=false;
bShow.Default:=false;
if universe.Visible then universe.Close;
frozen:=true;
  if bServer.Caption='Cancel' then begin
  bStart.Enabled:=true; seWin.Enabled:=true;
  cbGameType.Enabled:=true;listMap.Enabled:=true;
  end; // Reset GUI
end;

procedure Tpregame.restore;
var i:integer;
begin
  // Reset
for i:=1 to 32 do clientsid[i]:=0;
datatext:='';
textosend:='';
shcnt:=0;
shptr:=1;
ingame:=false;
bClient.Caption:='Join';
bServer.Caption:='Create';
bServer.enabled:=true;
bClient.enabled:=true;
eAddress.Enabled:=true;
eName.Enabled:=true;
cbGameType.Enabled:=true;
listMap.Enabled:=true;
listMap.Font.Color:=clBlack;
seWin.Enabled:=true;
bStart.Enabled:=false;
bStart.Default:=true;
bShow.Enabled:=false;
end;

procedure Tpregame.bExitClick(Sender: TObject);
begin
Application.Terminate;
end;

procedure Tpregame.bMinimizeClick(Sender: TObject);
begin
pregame.WindowState:=wsMinimized;
end;

procedure Tpregame.addteamtable;
var i,j,ptr:integer;
teamtable:string;
ttok:boolean;
begin

// Prida tabulku s tymy do hromadne rozesilane zpravy

teamtable:='';
ptr:=0;

for i:=1 to 20 do teamcolor[i]:=clNone;

for i:=1 to 32 do
if clientsid[i]<>0 then begin

ttok:=true;
for j:=1 to ptr do if clientstcolor[i]=teamcolor[j] then ttok:=false;

if ttok then begin
ptr:=ptr+1; teamcolor[ptr]:=clientstcolor[i];
end;

end;

for i:=1 to spawnscnt do
teamtable:=teamtable+colortostring(teamcolor[i])+'`';
  //Vezme prvnich nekolik tymu, ktere se vejdou na mapu

if teamtable<>'' then begin
teamtable:='tem00000000'+teamtable+'#';
datatext:=datatext+teamtable; // Pridani do fronty
end;

end;

procedure Tpregame.addclientable;
var i:integer;
clientable:string;
begin

// Prida seznam hracu do hromadne zpravy

clientable:='';
for i:=1 to 32 do begin
if clientsid[i]<>0 then
  clientable:=clientable+inttostr(i)+'`'
  +inttostr(clientsid[i])+'`'
  +clientsname[i]+'`'
  +colortostring(clientscolor[i])+'`'
  +colortostring(clientstcolor[i])+'`';
end;

if clientable<>'' then begin
clientable:='tab00000000'+clientable+'#';
datatext:=clientable+datatext;
end;

end;

procedure Tpregame.addcubetable;
var i:integer;
cubetable:string;
begin

// Prida seznam kostek do hromadne zpravy

cubetable:='';
for i:=1 to spawnscnt do begin
  cubetable:=cubetable
  +'i'+inttostr(i)+'`'
  +'x'+floattostr(cux[i])+'`'
  +'y'+floattostr(cuy[i])+'`'
  +'z'+floattostr(cuz[i])+'`'
  +'a'+floattostr(cuax[i])+'`'
  +'b'+floattostr(cuay[i])+'`'
  +'c'+floattostr(cuaz[i])+'`';
end;

if cubetable<>'' then begin
cubetable:='cub00000000'+cubetable+'#';
datatext:=cubetable+datatext;
end;


end;

procedure Tpregame.addshotable;
var i:integer;
shotable:string;
begin

// Prida seznam strel do hromadne zpravy

shotable:='n'+inttostr(shcnt)+'`';
for i:=1 to shcnt do begin
shotable:=shotable+'i'+inttostr(i)+'`';
if shact[i] then
shotable:=shotable+
'j1`'+
't'+inttostr(sht[i])+'`'+
's'+inttostr(shs[i])+'`'+
'k'+floattostr(shx[i])+'`'+
'l'+floattostr(shy[i])+'`'+
'm'+floattostr(shz[i])+'`'+
'x'+floattostr(shax[i])+'`'+
'y'+floattostr(shay[i])+'`'+
'z'+floattostr(shaz[i])+'`'
else
shotable:=shotable+'j0`';
end;

shotable:='sht00000000'+shotable+'#';
datatext:=shotable+datatext;

end;

procedure Tpregame.bStartClick(Sender: TObject);
var
i:integer;
winstr:string;
begin

// Spusteni hry

for i:=1 to 20 do begin
cux[i]:=cuxb[i];cuy[i]:=cuyb[i];cuz[i]:=cuzb[i];
end;

addcubetable;
addclientable;
addteamtable;

str(seWin.Value:4,winstr);

// Rozeslani informace o spusteni hry
datatext:=datatext+
'str00000000#'+
'gst00000000'+inttostr(cbGameType.ItemIndex)+winstr+mapname+'#'+
'msg00000000The Game started.#';

bStart.Enabled:=false;

end;

procedure Tpregame.sClientRead(Sender: TObject; Socket: TCustomWinSocket);
var textus:string;
begin
// Prijem zpravy
textus:=socket.ReceiveText;
getmessage(textus);
end;

procedure Tpregame.getmessage(var textus:string);
var
winstr,text,thetype,therest,thename,temp,teamtextx:string;
err,txlength,theid,i,ii,j,il,ptr:integer;
//tf:textfile;
readno:boolean;
varia:char;
begin

// Dekodovani zpravy

txlength:=length(textus);
if txlength>0 then if textus[txlength]<>'#' then textus:='';

il:=0;

while (textus<>'') do begin

j:=0; while textus[j]<>'#' do j:=j+1;

text:=copy(textus,1,j);
textus:=copy(textus,j+1,length(textus)-j);
thetype:=Copy(text,1,3);
val(Copy(text,4,8),theid,err);
therest:=Copy(text,12,length(text)-12);
temp:='';

if il>txlength then thetype:='n/a';

// podle predpony useku textu se zmeni konkretni data

if thetype='chg' then begin // nastaveni informaci o hraci

j:=0;i:=0;while (i<32) and (clientsid[i]<>theid) do
begin
i:=i+1;if (clientsid[i]=0) and (j=0) then j:=i;
end;

if (i<32) or ((j>0) and (j<32)) then begin
if i<32 then j:=i;
  ii:=1;while therest[ii]<>'`' do ii:=ii+1;
  clientsname[j]:=copy(therest,1,ii-1);
  therest:=copy(therest,ii+1,length(therest)-ii);
  ii:=1;while therest[ii]<>'`' do ii:=ii+1;
  clientscolor[j]:=stringtocolor(copy(therest,1,ii-1));
  therest:=copy(therest,ii+1,length(therest)-ii);
  temp:=colortostring(clientstcolor[j]);
  clientstcolor[j]:=stringtocolor(therest);
end;
if i=32 then begin
  log.Lines.add(clientsname[j]+' has connected.');
  clientsid[j]:=theid;
end;

if bServer.Caption='Cancel' then begin
str(seWin.Value:4,winstr);
datatext:=datatext+
'gst00000000'+inttostr(cbGameType.ItemIndex)+winstr+mapname+'#';
addteamtable;
addcubetable;
end;

end else if thetype='qdc' then begin // Zruseni serveru
frozen:=true;
universe.Close;
clientdisconnect;

end else if thetype='dis' then begin // Hrac se odpojil
i:=0; while i<=32 do begin i:=i+1;
if clientsid[i]=theid then begin
log.Lines.add(clientsname[i]+' has disconnected.');
clientsid[i]:=0;
clientsname[i]:='';
i:=33;
end;end;
if bServer.Caption='Cancel' then addteamtable;

end else if thetype='frg' then begin // Nekdo byl zastrelen
il:=strtoint(therest);
i:=0; while (i<32) and (clientsid[i]<>theid) do i:=i+1;
j:=0; while (j<32) and (clientsid[j]<>il) do j:=j+1;

if i<>j then begin

  if theid=clientid then
    begin universe.died ;hits:=hits+1;
    universe.planecrash; universe.reinfo; end;
  if il=clientid then
    begin
    if (gametype=0) or (clientstcolor[i]<>clientstcolor[j]) then frags:=frags+1;
    if (gametype<2) and (frags>=winumber) then
    clientdatatext:=clientdatatext+'win'+inttostr(clientid)+eName.text+'#'
    +'msg00000000The Game ended.#';
    universe.reinfo; end;

end;

end else if thetype='hit' then begin // nekdo byl strefen
il:=strtoint(copy(therest,2,length(therest)-1));
i:=0; while (i<32) and (clientsid[i]<>theid) do i:=i+1;
j:=0; while (j<32) and (clientsid[j]<>il) do j:=j+1;

if i<>j then if (gametype=0) or (clientstcolor[i]<>clientstcolor[j]) then begin

  if activ and (il=clientid) then
    begin
    if therest[1]='0' then
      universe.sndplay('hit.wav',8,4) else universe.sndplay('bighit.wav',8,6);
    whohit:=theid;
    if therest[1]='0' then energy:=energy-energym0 else energy:=energy-energym1;
    if energy<=0 then clientdatatext:=clientdatatext+'frg'
      +inttostr(clientid)+inttostr(whohit)+'#';
    universe.reinfo; end;

  if activ and (theid=clientid) then
    universe.sndplay('mhit.wav',1,4);

end;

end else if thetype='nsh' then begin // nova strela
if bServer.Caption='Cancel' then begin

while shact[shptr] do shptr:=shptr+1;
if shptr>shcnt then shcnt:=shptr;
shact[shptr]:=true;
shs[shptr]:=0;
showner[shptr]:=theid;
therest:=therest+'#';
readno:=false;
varia:=' ';

i:=1;
while therest[i]<>'#' do begin
  if not readno then begin
  varia:=therest[i];readno:=true
  end else begin
  if therest[i]<>'`' then
    temp:=temp+therest[i]
  else
    begin
      case varia of
      't':sht[shptr]:=strtoint(temp);
      'k':shx[shptr]:=strtofloat(temp);
      'l':shy[shptr]:=strtofloat(temp);
      'm':shz[shptr]:=strtofloat(temp);
      'a':shxp[shptr]:=strtofloat(temp);
      'b':shyp[shptr]:=strtofloat(temp);
      'c':shzp[shptr]:=strtofloat(temp);
      'x':shax[shptr]:=strtofloat(temp);
      'y':shay[shptr]:=strtofloat(temp);
      'z':shaz[shptr]:=strtofloat(temp);
      end;
    temp:='';
    readno:=false;
    end;
  end;
  i:=i+1;
end;

end;

end else if thetype='sht' then begin // Informace o leticich strelach

ingame:=true;
therest:=therest+'#';
readno:=false;
varia:=' ';

ptr:=0;
i:=1;
while therest[i]<>'#' do begin
  if not readno then begin
  varia:=therest[i];readno:=true;
  end else begin
  if therest[i]<>'`' then
    temp:=temp+therest[i]
  else
    begin
      case varia of
      'n':shcnt:=strtoint(temp);
      'i':ptr:=strtoint(temp);
      'j':if temp='0' then shact[ptr]:=false else shact[ptr]:=true;
      's':shs[ptr]:=strtoint(temp);
      't':sht[ptr]:=strtoint(temp);
      'k':shx[ptr]:=strtofloat(temp);
      'l':shy[ptr]:=strtofloat(temp);
      'm':shz[ptr]:=strtofloat(temp);
      'a':shxp[ptr]:=strtofloat(temp);
      'b':shyp[ptr]:=strtofloat(temp);
      'c':shzp[ptr]:=strtofloat(temp);
      'x':shax[ptr]:=strtofloat(temp);
      'y':shay[ptr]:=strtofloat(temp);
      'z':shaz[ptr]:=strtofloat(temp);
      end;
    temp:='';
    readno:=false;
    end;
  end;
  i:=i+1;
end;

end else if thetype='cub' then begin // Informace o kostkach

therest:=therest+'#';
readno:=false;
varia:=' ';

ptr:=0;
i:=1;
while therest[i]<>'#' do begin
  if not readno then begin
  varia:=therest[i];readno:=true;
  end else begin
  if therest[i]<>'`' then
    temp:=temp+therest[i]
  else
    begin
      case varia of
      'i':ptr:=strtoint(temp);
      's':begin cubehappen:=strtoint(temp);
          j:=0; while (j<32) and (clientsid[j]<>theid) do j:=j+1;
            if (pregame.cColor.Selected=teamcolor[ptr]) and
              (cubehappen=1) then cubehappen:=31;
            if (pregame.cColor.Selected=clientstcolor[j]) and
              (cubehappen=9) then begin
              cubes:=cubes+1;end;
            if theid=clientid then
              cubehappen:=cubehappen+10
            else if (pregame.cColor.Selected=clientstcolor[j]) then
              cubehappen:=cubehappen+20
            else if cubehappen=9 then cubehappen:=50+j;
            universe.reinfo;
          end;
      'o':begin cuowner[ptr]:=strtoint(temp); end;
      'x':cux[ptr]:=strtofloat(temp);
      'y':cuy[ptr]:=strtofloat(temp);
      'z':cuz[ptr]:=strtofloat(temp);
      'a':cuax[ptr]:=strtofloat(temp);
      'b':cuay[ptr]:=strtofloat(temp);
      'c':cuaz[ptr]:=strtofloat(temp);
      end;
    temp:='';
    readno:=false;
    end;
  end;
  i:=i+1;
end;

end else if thetype='dat' then begin // informace o hracich
universe.setdata(text); // ulozeni informaci o hracich
end else if thetype='tem' then begin // informace o tymech
i:=1;
ii:=0;
therest:=therest+'#';
repeat
temp:='';while therest[i]<>'`' do begin
temp:=temp+therest[i];i:=i+1; end;
ii:=ii+1;
teamcolor[ii]:=stringtocolor(temp);
i:=i+1;
until therest[i]='#';
for i:=1 to ii do if cColor.Selected=teamcolor[i] then teamid:=i;

teamtextx:='';
teamtextx:=teamtextx+'Active Teams: ';
for i:=1 to spawnscnt do
teamtextx:=teamtextx+Copy(colortostring(teamcolor[i]),3,
length(colortostring(teamcolor[i]))-2)+'; ';

if teamtext<>teamtextx then log.lines.Add(teamtextx);
teamtext:=teamtextx;

end else if thetype='tab' then begin // nastaveni informaci o hracich
therest:=therest+'#';
i:=1;
repeat
temp:='';while therest[i]<>'`' do begin
temp:=temp+therest[i];i:=i+1; end;
ptr:=strtoint(temp);
i:=i+1;
temp:='';while therest[i]<>'`' do begin
temp:=temp+therest[i];i:=i+1; end;
clientsid[ptr]:=strtoint(temp);
i:=i+1;
temp:='';while therest[i]<>'`' do begin
temp:=temp+therest[i];i:=i+1; end;
clientsname[ptr]:=temp;
i:=i+1;
temp:='';while therest[i]<>'`' do begin
temp:=temp+therest[i];i:=i+1; end;
clientscolor[ptr]:=stringtocolor(temp);
i:=i+1;
temp:='';while therest[i]<>'`' do begin
temp:=temp+therest[i];i:=i+1; end;
clientstcolor[ptr]:=stringtocolor(temp);
application.ProcessMessages;
i:=i+1;
until therest[i]='#';

end else if thetype='gst' then begin // nastaveni hry - typ, mapa, podminky

gametype:=strtoint(therest[1]);
winumber:=strtoint(copy(therest,2,4));

mapname:=copy(therest,6,length(therest)-5);

for i:=0 to listMap.Count-1 do
if listmap.Items[i]=mapname then listmap.Selected[i]:=true;

universe.loadmap('maps\'+mapname);

if bClient.Caption='Leave' then begin
seWin.Value:=winumber;
cbGameType.ItemIndex:=gametype;
if cbGameType.ItemIndex=2 then
lWin.Caption:='Cubes:' else
lWin.Caption:='Kills:';
end;

end else if thetype='str' then begin // Spusteni hry
shcnt:=0;shptr:=1;
frags:=0;hits:=0;
k:=10000;l:=10000;m:=10000;
winid:=0;winname:='';
ingame:=true;
universe.reinfo;
cbGameType.Enabled:=false;
seWin.Enabled:=false;
listMap.Enabled:=false;
listMap.Font.Color:=clMedGray;
universe.show;

end else if thetype='msg' then begin // zprava do logu
log.Lines.add(therest);

end else if thetype='cht' then begin // zprava hracum
i:=0;
if theid=0 then begin;thename:='The Server';i:=33;end;
while i<=32 do begin i:=i+1;
if clientsid[i]=theid then begin
thename:=clientsname[i];
i:=33;
end;end;
chat.Lines.add(thename+': '+therest);

end else if thetype='win' then begin // vyherce
frozen:=true;shcnt:=0;winid:=theid;winname:=therest;
universe.reinfo;
bShow.Enabled:=false;
bShow.Default:=false;

end else if thetype='new' then begin // nova hra
newgame;
end;

end;

end;

procedure Tpregame.bServerClick(Sender: TObject);
var i:integer;
begin

// Spusteni / vypnuti serveru

bServer.Default:=false;
if bServer.Caption='Create' then begin

datatext:='';
bServer.Caption:='Cancel';
bClient.enabled:=false;

sServer.Port:=3201;
sServer.Open;
bStart.enabled:=true;
log.Lines.add('The Server created.');

universe.loadmap('maps\'+mapname);

eAddress.Text:='127.0.0.1';
sleep(30);
application.ProcessMessages;
sleep(30);
clientconnect;

end else begin

datatext:='';
for i:=0 to sServer.Socket.ActiveConnections-1 do begin
sServer.Socket.Connections[i].SendText
('msg00000000The Server cancelled.#qdc00000000#');

end;
application.ProcessMessages;
sleep(200);
application.ProcessMessages;
sServer.Close;
restore;

end;

end;

procedure Tpregame.sServerClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var gettext:string;
begin
// pripojeni prijate zpravy do hromadne
gettext:=socket.ReceiveText;
if gettext[length(gettext)]='#' then datatext:=datatext+gettext;
end;

procedure Tpregame.chronoTimer(Sender: TObject);
var
i,j,ii,who,whom:integer;
temp1,temp2,shspeed,tempratio,tempx,tempy,tempz:double;
hit:boolean;
begin

  // co se ma dit kazdou chvili

  if not eName.enabled then begin
sClient.Socket.SendText(textosend);
textosend:='';
  end;

if (bServer.Caption='Cancel') then begin

  if ingame then begin // pokud se hraje

for i:=1 to shcnt do
if shact[i] then begin // strely
who:=0;whom:=0;
hit:=false;

if sht[i]=1 then begin // navadena strela
  shxp[i]:=sin(shay[i]/57.2958)*cos(shax[i]/57.2958);
  shyp[i]:=-sin(shax[i]/57.2958);
  shzp[i]:=-cos(shay[i]/57.2958)*cos(shax[i]/57.2958);

  if shs[i]=0 then begin // nema zamereno - hleda si cil
    tempratio:=rocketratio;
    for j:=1 to 32 do if (clientsid[j]<>showner[i]) and (clientsid[j]<>0) then begin
      temp1:=distance(shx[i],shy[i],shz[i],ks[j],ls[j],ms[j]);
      tempx:=shx[i]+temp1*shxp[i];
      tempy:=shy[i]+temp1*shyp[i];
      tempz:=shz[i]+temp1*shzp[i];
      temp2:=distance(tempx,tempy,tempz,ks[j],ls[j],ms[j])/temp1;
      if temp2<tempratio then begin shs[i]:=j;tempratio:=temp2; end;
    end;
  end;
  j:=0;
  if shs[i]>0 then begin // ma zamereno - porad ma zamereno?
    j:=shs[i];
    temp1:=distance(shx[i],shy[i],shz[i],ks[j],ls[j],ms[j]);
    tempx:=shx[i]+temp1*shxp[i];tempy:=shy[i]+temp1*shyp[i];tempz:=shz[i]+temp1*shzp[i];
    temp2:=distance(tempx,tempy,tempz,ks[j],ls[j],ms[j])/temp1;
    tempratio:=temp2;
    if tempratio>rocketratio then shs[i]:=0;
  end;
  if shs[i]>0 then begin // ma zamereno - zataci k cili
    for ii:=1 to 4 do begin
      case ii of // vyzkousi se pohnout, pokud se priblizi, tak se tak pohne
        1:shay[i]:=shay[i]+rocketap; 2:shay[i]:=shay[i]-rocketap;
        3:shax[i]:=shax[i]+rocketap; 4:shax[i]:=shax[i]-rocketap;
      end;
      shxp[i]:=sin(shay[i]/57.2958)*cos(shax[i]/57.2958);
      shyp[i]:=-sin(shax[i]/57.2958);
      shzp[i]:=-cos(shay[i]/57.2958)*cos(shax[i]/57.2958);
      temp1:=distance(shx[i],shy[i],shz[i],ks[j],ls[j],ms[j]);
      tempx:=shx[i]+temp1*shxp[i];tempy:=shy[i]+temp1*shyp[i];tempz:=shz[i]+temp1*shzp[i];
      temp2:=distance(tempx,tempy,tempz,ks[j],ls[j],ms[j])/temp1;
      if temp2>=tempratio then begin
      case ii of
        1:shay[i]:=shay[i]-rocketap; 2:shay[i]:=shay[i]+rocketap;
        3:shax[i]:=shax[i]-rocketap; 4:shax[i]:=shax[i]+rocketap;
      end; end else tempratio:=temp2;
    end;
    shxp[i]:=sin(shay[i]/57.2958)*cos(shax[i]/57.2958);
    shyp[i]:=-sin(shax[i]/57.2958);
    shzp[i]:=-cos(shay[i]/57.2958)*cos(shax[i]/57.2958);
  end;
end; //OF SHT[i]=1

  if sht[i]=0 then shspeed:=shspeed0 else shspeed:=shspeed1;

  for j:=1 to round(shspeed)+1 do begin // posun strely
    shx[i]:=shx[i]+shxp[i]*(shspeed/(round(shspeed)+1));
    shy[i]:=shy[i]+shyp[i]*(shspeed/(round(shspeed)+1));
    shz[i]:=shz[i]+shzp[i]*(shspeed/(round(shspeed)+1));
    for ii:=1 to 32 do
      if clientsid[ii]<>0 then
        if sqrt(sqr(shx[i]-ks[ii])+sqr(shy[i]-ls[ii])+sqr(shz[i]-ms[ii]))<2 then
          begin hit:=true;who:=showner[i];whom:=clientsid[ii] end; // zasah!
  end;

  if hit then // pokud strela zasahla
    datatext:=datatext+'hit'+inttostr(who)+inttostr(sht[i])+inttostr(whom)+'#';

  if (universe.crash(shx[i],shy[i],shz[i])<0.5) or hit then
  begin // zruseni strely a zkraceni zasobniku strel
    shact[i]:=false;
    if shptr>i then shptr:=i;
    while (not shact[shcnt]) and (shcnt>0) do shcnt:=shcnt-1;
  end;

end;
addshotable; // pridani strel do hromadne zpravy

  end;

addclientable; // pridani hracu do hromadne zpravy

end;

  if gametype=2 then // hraji se kostky
    for i:=1 to 20 do if teamcolor[i]<>clNone then begin
      cuax[i]:=cuax[i]+1;if cuax[i]>=360 then cuax[i]:=cuax[i]-360;
      cuay[i]:=cuay[i]+2;if cuay[i]>=360 then cuay[i]:=cuay[i]-360;
      cuaz[i]:=cuaz[i]+3;if cuaz[i]>=360 then cuaz[i]:=cuaz[i]-360;
  end;

  if length(datatext)>0 then if datatext[length(datatext)]='#' then
  for i:=0 to sServer.Socket.ActiveConnections-1 do
    sServer.Socket.Connections[i].SendText(datatext);
      // rozeslani hromadne zpravy

  datatext:='';

  if quitsoon then begin // pripravuje se vypnuti hry
    if quithowsoon=0 then application.Terminate;
    quithowsoon:=quithowsoon-1;
  end;

end;

function Tpregame.distance(x1,y1,z1,x2,y2,z2:double):double;
begin
  // vypocet euklidovske vzdalenosti
distance:=sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)+(z1-z2)*(z1-z2));
end;

procedure Tpregame.bChatClick(Sender: TObject);
var i:integer;
temp:string;
begin
  // odeslani zpravy bezzakazanich znaku
bChat.Default:=false;
temp:=eChat.Text;
for i:=1 to length(temp) do if temp[i]='#' then temp[i]:='*';
eChat.Text:=temp;
textosend:=textosend+'cht'+inttostr(clientid)+eChat.Text+'#';
eChat.Text:='';
end;

procedure Tpregame.sColorMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if cDialog.Execute then begin
sColor.Brush.Color:=cDialog.Color;
reactual;
end;
end;

procedure Tpregame.cColorChange(Sender: TObject);
begin
reactual;
end;

procedure Tpregame.reactual;
var i:integer;
begin
  // aktualizace nastaveni hrace
if not eName.Enabled then begin
i:=0; while clientsid[i]<>clientid do i:=i+1;
clientscolor[i]:=sColor.Brush.Color;
clientstcolor[i]:=cColor.Selected;
textosend:=textosend+('chg'+inttostr(clientid)
+clientsname[i]+'`'
+colortostring(clientscolor[i])+'`'
+colortostring(clientstcolor[i])+'#');
end;
end;


procedure Tpregame.bEndClick(Sender: TObject);
begin
ingame:=false;
quithowsoon:=1;
if bServer.Caption='Cancel' then
begin bServerClick(Sender); quithowsoon:=10; end;
if bClient.Caption='Leave' then
begin bClientClick(Sender); quithowsoon:=10; end;
quitsoon:=true;
end;

procedure Tpregame.seWinChange(Sender: TObject);
var winstr:string;
begin
winumber:=seWin.value;
  // nastaveni hry
str(winumber:4,winstr);
datatext:=datatext+
'gst00000000'+inttostr(cbGameType.ItemIndex)+winstr+mapname+'#';
end;


procedure Tpregame.cbGameTypeChange(Sender: TObject);
var winstr:string;
begin
if cbGameType.ItemIndex=2 then
lWin.Caption:='Cubes:' else
lWin.Caption:='Kills:';

str(seWin.Value:4,winstr);
datatext:=datatext+
'gst00000000'+inttostr(cbGameType.ItemIndex)+winstr+mapname+'#';
end;

procedure Tpregame.listMapChange(Sender: TObject);
var
winstr:string;
begin
if listmap.ItemIndex>=0 then begin
mapname:=listMap.items[listmap.ItemIndex];

str(seWin.Value:4,winstr);
datatext:=datatext+
'gst00000000'+inttostr(cbGameType.ItemIndex)+winstr+mapname+'#';
universe.loadmap('maps\'+mapname); // nacteni mapy
addteamtable;
end;
end;

// ZREJME PROCEDURY

procedure Tpregame.bShowClick(Sender: TObject);
begin
universe.Show;
end;

procedure Tpregame.eNameEnter(Sender: TObject);
begin
bServer.Default:=true;
bClient.Default:=false;
end;

procedure Tpregame.eAddressEnter(Sender: TObject);
begin
bServer.Default:=false;
bClient.Default:=true;
end;

procedure Tpregame.eChatChange(Sender: TObject);
begin
bServer.Default:=false;
bClient.Default:=false;
bChat.Default:=true;
end;


procedure Tpregame.FormCreate(Sender: TObject);
begin
listmap.ItemIndex:=0;
mapname:=listMap.Items[0];
end;

initialization

// Pocatecni nastaveni

randomize;
frozen:=true; // Hra nebezi
clientid:=random(round(1E8)-round(1E7))+round(1E7); // Generovani meho ID

rocketratio:=0.25; // Navadeni rakety - zorny uhel pro zamereni cile
rocketap:=0.3; // Navadeni rakety - rychlost zmeny smeru
winid:=0;
energymax:=100
energy:=100;
energym0:=10; // Zivoty ubrane strelou
energym1:=35; // Zivoty ubrane raketou
radarzoom:=250;
speedp:=1.5; // Mozne zrychleni letounu
resist:=0.99; // Odpor vzduchu
grav:=0.08; // Gravitace
uplift:=3; // Vztlak
frags:=0;
hits:=0;
angp:=8; // Rychlost otaceni letounu v transversalni rovine
anghp:=1; // Rychlost otaceni letounu v sagitalni rovine
angrp:=1; // Rychlost otaceni letounu ve ventralni rovine
angr:=0;
ang:=0;     // Korespondujici uhly
angh:=0;
reloadmax:=4; // Doba nabiti pred dalsim vystrelem
mrelmax:=100; // Maximalni mnozstvi energie
shspeed0:=6; // rychlost strely
shspeed1:=1.8; // rychlost rakety
inactlong:=0;
inactlongmax:=1000; // Doba neaktivity pred odpojenim
sndlength:=0;
sndprior:=0; // Reset zvuku
view:=0; // Zakladni pohled

// Nacteni grafiky 
universe.loadplane('plane.map');
universe.loadshot('shot.map');
universe.loadrocket('rocket.map');
universe.loadcube('cube.map');

end.


