unit uUniverse;

interface

uses
  Math, Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, glWindow, gl, glut, glaux, StdCtrls, abfComponents;

type
  Tuniverse = class(TForm)
    world: TglWindow; // Scena
    tim: TTimer; // Herni casovac (1/FPS)
    info: TLabel; // Frags, hits, cubes
    sound: TabfWav; // Generator zvukovych efektu
    procedure worldDraw(Sender: TObject); // Prekresleni sveta
    procedure timTimer(Sender: TObject); // Co se ma dit kazdou chvili
    procedure changes; // Provadeni zmen souvisejicich primo s hracem
    procedure respawn; // Oziveni po zniceni
    procedure reinfo; // Aktualizace hernich informaci
    procedure died; // V okamziku zniceni
    procedure setdata(msg:string); // Aktualizace dat podle zpravy ze site
    function crash(x,y,z:double):double; // Vzdalenost od nejblizsiho predmetu
    function littlerand:double; // Generovani rozptylu strely pri vystrelu
    function prevh:double; // Vyskovy tres
    procedure planecrash; // Naraz letadla
    procedure replacecube(index,style:integer); // Zobrazeni krychle v situaci
    procedure setColor(theColor:TColor); // Nastaveni barvy pred vykreslenim
    procedure putpoint(x,y,z:double); // Vykresleni bodu v OpenGL
    procedure putplane(x,y,z,xang,yang,zang:double;planei:integer);
      // Zobrazeni letounu
    procedure putshot(shoti:integer); // Zobrazeni strely
    procedure putrocket(shoti:integer); // Zobrazeni rakety
    procedure putcube(cubei:integer;freecube:integer); // Zobrazeni krychle
    procedure sndplay(filename:string;prior,length:integer); // Zahrat zvuk
    procedure loadmap(filename:string); // Nacteni mapy
    procedure loadplane(filename:string); // Nacteni letounu
    procedure loadrocket(filename:string); // Nacteni rakety
    procedure loadshot(filename:string); // Nacteni strely
    procedure loadcube(filename:string); // Nacteni krychle
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState); // Stisk klavesy
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState); // Pusteni klavesy
    procedure FormKeyPress(Sender: TObject; var Key: Char);
      // Jiny stisk klavesy
    procedure FormShow(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject); // Po zobrazeni sceny
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  universe: Tuniverse; // Formular
  frozen:boolean; // Je hra prerusena/jeste nezacala?
  hover,speed,speedp,resist,grav,uplift:double;
    // Kolma rychlost, rychlost vpred, zrychleni, odpor vzduchu, gravitace,
      // vztlak
  setrh,angr,angrp,angp,anghp,ang,angh:double;
    // Zmena uhlu nahoru/dolu; zmeny uhlu, uhly
  kp,lp,mp:double; // Rychlost
  k,l,m:double; // Souradnice
  carry:integer; // Kterou nesu kostku
  energy,energymax,energym0,energym1:double; // Zivoty, jejich ubytek
  keys:array[0..255] of boolean; // Klavesy (stisknutost)
  polycnt:integer; // Pocet polygonu na mape
  cubepolycnt:integer; // Pocet polygonu na kostce
  planepolycnt:integer; // Pocet polygonu na letadle
  rocketpolycnt,shotpolycnt:integer; // P. p. na rakete, strele
  activ:boolean; // Aktivita letounu
  frags,hits,cubes,cubehappen,whohit:integer;
    // body, zniceni, pocet krychli, co se deje s krychli, kdo me strefil
  mrel,mrelmax,reload,reloadmax,infolength:integer;
    // energie, max. e., stav nabijeni, max. s. n., aktualizace info
  rocketap,rocketratio,blink,inactlong,inactlongmax:double;
    // navadenost rakety; blikani kontrolky krychle; neaktivita pred odpojenim
  polypoints:array[0..1023] of integer; // body polygonu
  polyid:array[0..1023] of integer; // druh polygonu
  polyr,polyg,polyb:array[0..1023,0..32] of double; // barva bodu
  polyx,polyy,polyz:array[0..1023,0..32] of double; // souradnice bodu
  spawnscnt:integer; // pocet tymu na mape
  spawncnt:array[0..20] of integer; // pocet obnovovacich mist pro tym
  spawnx,spawny,spawnz, // souradnice obnov. mista
  spawnax,spawnay,spawnaz // natoceni letounu na obn. miste
  :array[0..20,0..32] of double;
  clientdatatext:string; // odesilana zprava
  sndprior,sndlength:integer; // zvukove priznaky

implementation

uses uPregame;

{$R *.dfm}
procedure Tuniverse.sndplay(filename:string;prior,length:integer);
begin // Prehravani zvuku pomoci specialni komponenty

  // zvuk ma vetsi prioritu nez prave hrany
if (prior>sndprior) or (sndlength=0) then begin
if pregame.cbSnd.Checked then begin
sound.FileName:=filename;sound.play;
end;
sndlength:=length;sndprior:=prior;
end;

end;

procedure Tuniverse.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=83 then pregame.cbSnd.Checked:=not pregame.cbSnd.Checked; // zvuk
if key=86 then begin view:=view+1; if view=2 then view:=0; end; // pohled

if (key=107) and (radarzoom>10) then radarzoom:=radarzoom*0.8; // zvetseni
if (key=109) and (radarzoom<1000) then radarzoom:=radarzoom/0.8; //radaru

keys[key]:=true; // nastavi klavesu jako stisknutou
end;

procedure Tuniverse.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
keys[key]:=false; // odzmackne klavesu
end;

procedure Tuniverse.FormResize(Sender: TObject);
begin
info.Font.Size:=round(universe.ClientHeight/30);
  // zmena velikosti infa podle velikosti okna
end;

procedure Tuniverse.reinfo;
var i:integer;
begin
if (cubehappen>0) then begin
info.Font.Color:=clRed;
infolength:=round(1500/tim.Interval); // Jak dlouho tam bude info trcet
case cubehappen of // Nastaveni infa podle priznaku
1:info.Caption:='Someone has stolen some cube!';
31:begin info.Caption:='Your cube has been stolen!';sndplay('stolen.wav',8,30);end;
11:begin info.Caption:='You'+#39+'ve got a cube!';sndplay('laugh.wav',8,40);end;
12:info.Caption:='You'+#39+'ve lost a cube!';
18:info.Caption:='You'+#39+'ve retrieved the cube!';
28:info.Caption:='Your cube has been retrieved!';
19:begin info.Caption:='You'+#39+'ve get the cube to the destination!';
  universe.sndplay('cubed.wav',8,30);end;
29:begin info.Caption:='Your team scores a cube!';
  universe.sndplay('cubed.wav',8,30);end;
50..70:begin i:=cubehappen-50;info.Caption:=
Copy(colortostring(clientstcolor[i]),3,length(colortostring(clientstcolor[i]))-2)
+' team scores a cube!'; end;
end;
cubehappen:=0; // vypnuti priznaku
end;

    if infolength=0 then begin // Bezna zprava
info.Font.Color:=clYellow;
if winid=0 then begin // Zatim nikdo nevyhral
info.Caption:='Frags:'+inttostr(frags)+' Hits:'+inttostr(hits);
if gametype=2 then info.Caption:=info.Caption+' Cubes:'+inttostr(cubes);
end else begin // Je znam vyherce
i:=0; while (i<32) and (clientsid[i]<>winid) do i:=i+1;

  if (clientsid[i]=clientid) or
    ((gametype>0) and (clientstcolor[i]=pregame.cColor.Selected)) then begin

if gametype=0 then info.Caption:='You win the game!'
else info.Caption:='Your team wins the game!';

end else

if gametype=0 then info.Caption:=winname+' wins the game!'
else info.Caption:=
Copy(colortostring(clientstcolor[i]),3,length(colortostring(clientstcolor[i]))-2)
+' team wins the game!'

end;
    end;

end;

//************** LOADS *************** // Nacitani grafiky
procedure Tuniverse.loadmap(filename:string);
var
f:textfile;
id,i,j:integer;
begin
spawnscnt:=0;
assignfile(f,filename);
reset(f);
readln(f,polycnt); // Pocet polygonu
for i:=1 to polycnt do begin
readln(f,polyid[i]); // Typ polygonu
if polyid[i]<20 then begin // Klasicky polygon
  readln(f,polypoints[i]);
  for j:=1 to polypoints[i] do begin
    readln(f,polyr[i,j],polyg[i,j],polyb[i,j]);
    readln(f,polyx[i,j],polyy[i,j],polyz[i,j]);
  end;
end else if polyid[i]<50 then begin // Pomocny - obnovovaci misto
  id:=polyid[i]-20;
  if id>spawnscnt then spawnscnt:=id;
  readln(f,spawncnt[id]);
  for j:=1 to spawncnt[id] do begin
    readln(f,spawnax[id,j],spawnay[id,j],spawnaz[id,j]);
    readln(f,spawnx[id,j],spawny[id,j],spawnz[id,j]);
  end;
end else if polyid[i]=50 then begin // Pomocny - kostka
  readln(f,spawnscnt);
  for j:=1 to spawnscnt do begin
    readln(f,cuxb[j],cuyb[j],cuzb[j]);
  end;
end;
end;

closefile(f);
end;

// Vsechna grafika je nacitana podobne

procedure Tuniverse.loadplane(filename:string);
var
f:textfile;
tempcnt,i,j:integer;
begin
planepolycnt:=511;
assignfile(f,filename);
reset(f);
readln(f,tempcnt);
planepolycnt:=planepolycnt+tempcnt;
for i:=512 to planepolycnt do begin
readln(f,polypoints[i]);
for j:=1 to polypoints[i] do begin
readln(f,polyr[i,j],polyg[i,j],polyb[i,j]);
readln(f,polyx[i,j],polyy[i,j],polyz[i,j]);
end;
end;
closefile(f);
end;

procedure Tuniverse.loadshot(filename:string);
var
f:textfile;
tempcnt,i,j:integer;
begin
shotpolycnt:=767;
assignfile(f,filename);
reset(f);
readln(f,tempcnt);
shotpolycnt:=shotpolycnt+tempcnt;
for i:=768 to shotpolycnt do begin
readln(f,polypoints[i]);
for j:=1 to polypoints[i] do begin
readln(f,polyr[i,j],polyg[i,j],polyb[i,j]);
readln(f,polyx[i,j],polyy[i,j],polyz[i,j]);
end;
end;
closefile(f);
end;


procedure Tuniverse.loadrocket(filename:string);
var
f:textfile;
tempcnt,i,j:integer;
begin
rocketpolycnt:=831;
assignfile(f,filename);
reset(f);
readln(f,tempcnt);
rocketpolycnt:=rocketpolycnt+tempcnt;
for i:=832 to rocketpolycnt do begin
readln(f,polypoints[i]);
for j:=1 to polypoints[i] do begin
readln(f,polyr[i,j],polyg[i,j],polyb[i,j]);
readln(f,polyx[i,j],polyy[i,j],polyz[i,j]);
end;
end;
closefile(f);
end;

procedure Tuniverse.loadcube(filename:string);
var
f:textfile;
tempcnt,i,j:integer;
begin
cubepolycnt:=895;
assignfile(f,filename);
reset(f);
readln(f,tempcnt);
cubepolycnt:=cubepolycnt+tempcnt;
for i:=896 to cubepolycnt do begin
readln(f,polypoints[i]);
for j:=1 to polypoints[i] do begin
readln(f,polyr[i,j],polyg[i,j],polyb[i,j]);
readln(f,polyx[i,j],polyy[i,j],polyz[i,j]);
end;
end;
closefile(f);
end;

// ***************  TIMER ************** // Co se ma dit kazdou chvili
procedure Tuniverse.timTimer(Sender: TObject);
begin

if infolength>0 then begin // NEpravidelne obnovovani infa
infolength:=infolength-1;
if infolength=0 then reinfo;
end;

if not frozen then begin

if ingame then changes; // Zmeny letounu

// Odeslani mych vlastnosti serveru
// typ informace je prvni, 3znakove slovo
// informace jsou urcene pismenem, oddelovany `

clientdatatext:=
'dat'+inttostr(clientid)
+'n'+floattostr(inactlong)+'`'
+'f'+inttostr(carry)+'`'
+'k'+floattostr(k)+'`'
+'l'+floattostr(l)+'`'
+'m'+floattostr(m)+'`'
+'a'+floattostr(kp)+'`'
+'b'+floattostr(lp)+'`'
+'c'+floattostr(mp)+'`'
+'u'+floattostr(ang)+'`'
+'r'+floattostr(angr)+'`'
+'h'+floattostr(angh)+'`'
+'#'+clientdatatext;
end;
if universe.Visible then world.ReDraw;
if not pregame.eName.enabled then pregame.sClient.Socket.SendText(clientdatatext);
clientdatatext:='';

if sndlength>0 then sndlength:=sndlength-1; // Reseni zvuku
end;

//************* CHANGES *********************
procedure Tuniverse.changes;
var i,j:integer;
plus,tempx,tempy,tempz:double;
begin
if reload>0 then reload:=reload-1; // Nabijeni
if mrel<mrelmax then mrel:=mrel+1; // Dobijeni energie

  if activ then begin

hover:=hover*0.98; // Zklidnovani kolme rychlosti

if keys[18] and (mrel>=2) then begin hover:=hover+0.002;mrel:=mrel-2; end;
  // kolmy vzlet

if keys[37] then angr:=angr-angrp; // otaceni
if keys[39] then angr:=angr+angrp;

if not keys[37] and not keys[39] then angr:=angr*0.8 else angr:=angr*0.95;
ang:=ang+abs(sin(angr/57.2958))+sin(angr/57.2958)*angp;
  // usmernovani otaceni

if not keys[38] and not keys[40] then setrh:=setrh*0.3 else setrh:=setrh*0.8;
  // otaceni nahoru/dolu
if keys[38] then begin
setrh:=setrh+0.2;
end;
if keys[40] then begin
setrh:=setrh-0.2;
end;


angh:=angh+anghp*setrh;

// kontrola rotace
if ang>=360 then ang:=ang-360;
if ang<0 then ang:=ang+360;
if angh>=360 then angh:=angh-360;
if angh<0 then angh:=angh+360;

// zmeny rychlosti
plus:=(speedp-speed)/100;
if keys[13] then speed:=speed+plus;
if keys[8] then speed:=speed*0.95;

// osetreni proti deleni 0
if speed=0 then speed:=0.0000001;


angr:=angr+prevh;ang:=ang+prevh;angh:=angh+prevh;

  end;

kp:=sin(ang/57.2958)*cos(angh/57.2958)*speed;
mp:=-cos(ang/57.2958)*cos(angh/57.2958)*speed;
lp:=-sin(angh/57.2958)*speed-grav/(abs(speed)+uplift);

if not activ then lp:=lp-grav*(10-(inactlong/100)); // pad neaktivniho

// zpracovani dat pro odeslani
tempx:=kp/speed;
tempy:=-sin(angh/57.2958);
tempz:=mp/speed;

l:=l+hover;

// pokud tomu nic nebrani, pohyb
if not (crash(k,l,m)<2.5) or not (crash(k+kp,l+lp,m+mp)<2.5) then begin
k:=k+kp;m:=m+mp;l:=l+lp;
end;

if activ and keys[17] and (reload=0) and (mrel>=10) then begin
  // strela

sndplay('chain.wav',4,4);

mrel:=mrel-10; 
reload:=reloadmax;
clientdatatext:=clientdatatext+
'nsh'+inttostr(clientid)+
't0`'+
'k'+floattostr(k+1.5*kp+4*tempx)+'`'+
'l'+floattostr(l+1.5*lp+4*tempy)+'`'+
'm'+floattostr(m+1.5*mp+4*tempz)+'`'+
'a'+floattostr(tempx+littlerand)+'`'+
'b'+floattostr(tempy+littlerand)+'`'+
'c'+floattostr(tempz+littlerand)+'`'+
'x'+floattostr(angh)+'`'+
'y'+floattostr(ang)+'`'+
'z'+floattostr(angr)+'`'+'#';
  // odeslani dat serveru

end;

if activ and keys[32] and (reload=0) and (mrel>=70) then begin
  // raketa

sndplay('rocket.wav',5,10);

mrel:=mrel-70;
reload:=reloadmax;
clientdatatext:=clientdatatext+
'nsh'+inttostr(clientid)+
't1`'+
'k'+floattostr(k+1.5*kp+4*tempx)+'`'+
'l'+floattostr(l+1.5*lp+4*tempy)+'`'+
'm'+floattostr(m+1.5*mp+4*tempz)+'`'+
'a'+floattostr(tempx+littlerand)+'`'+
'b'+floattostr(tempy+littlerand)+'`'+
'c'+floattostr(tempz+littlerand)+'`'+
'x'+floattostr(angh)+'`'+
'y'+floattostr(ang)+'`'+
'z'+floattostr(angr)+'`'+'#';
  // odeslani dat serveru

end;

if activ and (crash(k,l,m)<2.5) then  // zmena zivota pri dotyku zeme
if l>1.5 then begin
if (speed>speedp/8) then universe.sndplay('hit.wav',8,4);
energy:=energy-(10*(speed-speedp/8)/speedp);
if energy>energymax then energy:=energymax;
end else begin
universe.sndplay('hit.wav',8,4);
energy:=energy-0.5;
end;

if (crash(k,l,m)<1.5) then energy:=0; // Zniceni rychlym narazem

if activ and (energy<=0) then begin  / zniceni letounu
planecrash;
frags:=frags-1; reinfo; died;
end;

if activ then for i:=1 to 20 do
if (gametype=2) and (teamcolor[i]<>clNone) and (cuowner[i]=0) then
    if sqrt((k-cux[i])*(k-cux[i])+(l-cuy[i])*(l-cuy[i])+(m-cuz[i])*(m-cuz[i]))<6 then
  if (carry=0) and (teamcolor[i]<>pregame.cColor.Selected) then
      begin carry:=i;replacecube(i,1);end // ukradeni krychle
  else if (teamcolor[i]=pregame.cColor.Selected) and // vraceni vlastni krychle
    (cux[i]<>cuxb[i]) or (cuy[i]<>cuyb[i]) or (cuz[i]<>cuzb[i]) then
      begin cux[i]:=cuxb[i];cuy[i]:=cuyb[i];cuz[i]:=cuzb[i];replacecube(i,8); end;

if activ then
for i:=1 to 32 do begin // bourani do jineho letounu
  if (clientsid[i]<>0) and (clientsid[i]<>clientid) then
  if sqrt((k-ks[i])*(k-ks[i])+(l-ls[i])*(l-ls[i])+(m-ms[i])*(m-ms[i]))<4 then
  begin
    energy:=energy-8;
    universe.sndplay('hit.wav',8,4);
    if energy<=0 then clientdatatext:=clientdatatext+'frg'
      +inttostr(clientid)+inttostr(clientsid[i])+'#';
  end;
end;

  if activ and (carry>0) then begin
   i:=0; while (i<32) and (clientsid[i]<>clientid) do i:=i+1;
   cux[carry]:=k;cuy[carry]:=l;cuz[carry]:=m;cuowner[carry]:=i;replacecube(carry,0);
     // prekresleni nesene krychle

   for i:=1 to 20 do
     if (teamcolor[i]=pregame.cColor.Selected) and (cuowner[i]=0) and
      (sqrt((k-cuxb[i])*(k-cuxb[i])+(l-cuyb[i])*(l-cuyb[i])+(m-cuzb[i])*(m-cuzb[i]))<6) then
        begin // doneseni krychle
        cux[carry]:=cuxb[carry];cuy[carry]:=cuyb[carry];cuz[carry]:=cuzb[carry];
        reinfo;cuowner[carry]:=0;replacecube(carry,9);carry:=0;
        if (cubes+1>=winumber) then clientdatatext:=clientdatatext
        +'win'+inttostr(clientid)+pregame.eName.text+'#'
        +'msg00000000The Game ended.#';
        end;
  end;

if not activ then begin

i:=0; while (i<32) and (clientsid[i]<>clientid) do i:=i+1;
for j:=1 to 20 do if (teamcolor[j]<>clNone) and (cuowner[j]=i) then begin
cuowner[j]:=0;replacecube(j,0); // obnoveni informace o nenesene krychli
end;

inactlong:=inactlong-tim.Interval; // Zmena doby neaktivity
if inactlong<=0 then begin // Potom se zrus
cleanresp:=false;
inactlong:=0;
respawn;
end;

end;

end;

procedure Tuniverse.died; // letoun byl znicen
begin

if carry>0 then begin // umisteni krychle
cux[carry]:=k;cuy[carry]:=l;cuz[carry]:=m;
cuowner[carry]:=0;replacecube(carry,2);carry:=0;
end;

activ:=false; inactlong:=inactlongmax;
end;

procedure Tuniverse.replacecube(index,style:integer); // info o kostce
var cubetable:string;
begin
cubetable:='i'+inttostr(index)+'`'
  +'o'+inttostr(cuowner[index])+'`'
  +'x'+floattostr(cux[index])+'`'
  +'y'+floattostr(cuy[index])+'`'
  +'z'+floattostr(cuz[index])+'`';
  if style>0 then cubetable:=cubetable+'s'+inttostr(style)+'`';
cubetable:='cub'+inttostr(clientid)+cubetable+'#';
clientdatatext:=clientdatatext+cubetable;
end;

function Tuniverse.littlerand:double; // pro rozptyl strel
var rand:double;
begin
rand:=random-0.5;
littlerand:=rand*rand*rand/15;
end;

function Tuniverse.prevh:double; // pro vyskove chveni
begin
prevh:=sqr(l/150)*(random-0.5);
end;

//************** CRASH ******************
function Tuniverse.crash(x,y,z:double):double;
var i,id:integer;
veca,vecb,vecc,vecd:double;
crashed,crashed2,temp:double;
begin
id:=-1;
crashed2:=1E6;
crashed:=1E6;

for i:=1 to polycnt do begin
if (polyid[i]<>id) and (polyid[i]<10) then
  begin
    if crashed>crashed2 then crashed:=crashed2;
    crashed2:=-1E6;
    id:=polyid[i];
  end;

// Projde vsechny polygony v terenu a spocita
// orientovanou vzdalenost od jejich rovin
// podle vzorce pro vzdalenost bodu od roviny

veca:=(polyy[i,3]-polyy[i,2])*(polyz[i,2]-polyz[i,1])
  -(polyy[i,2]-polyy[i,1])*(polyz[i,3]-polyz[i,2]);
vecb:=(polyx[i,2]-polyx[i,1])*(polyz[i,3]-polyz[i,2])
  -(polyx[i,3]-polyx[i,2])*(polyz[i,2]-polyz[i,1]);
vecc:=(polyx[i,3]-polyx[i,2])*(polyy[i,2]-polyy[i,1])
  -(polyx[i,2]-polyx[i,1])*(polyy[i,3]-polyy[i,2]);
vecd:=-(veca*polyx[i,1]+vecb*polyy[i,1]+vecc*polyz[i,1]);

if -((veca*x+vecb*y+vecc*z+vecd)/sqrt(veca*veca+vecb*vecb+vecc*vecc))>crashed2 then
  crashed2:=-((veca*x+vecb*y+vecc*z+vecd)/sqrt(veca*veca+vecb*vecb+vecc*vecc));

end;
crash:=crashed;
end;

//******************** BEGINNING ************************
procedure Tuniverse.respawn; // oziveni
var
respawnok:boolean;
spawnid,rand,i:integer;
begin
// reset nastaveni
speed:=0.0000001;
if gametype=0 then spawnid:=0 else spawnid:=teamid;
rand:=random(spawncnt[spawnid])+1;
angr:=spawnaz[spawnid,rand];
ang:=spawnay[spawnid,rand];
angh:=spawnax[spawnid,rand];
k:=spawnx[spawnid,rand];
l:=spawny[spawnid,rand];
m:=spawnz[spawnid,rand];

respawnok:=true; // kontrola, jestli se s nekym neprekryvam
for i:=1 to 32 do begin
  if (clientsid[i]<>0) and (clientsid[i]<>clientid) then
  if sqrt((k-ks[i])*(k-ks[i])+(l-ls[i])*(l-ls[i])+(m-ms[i])*(m-ms[i]))<6 then
  respawnok:=false;
end;

if respawnok then begin // aktivace
sndplay('respawn.wav',5,30);
energy:=energymax;
activ:=true;
end;

end;

//***************** WORLDDRAW *****************
procedure Tuniverse.worldDraw(Sender: TObject); // vykreslovani grafiky
var i,j:integer;temp1,temp2,temp3,tempc:double;
begin

  // inicializace
  glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
  glMatrixMode(GL_MODELVIEW);

//*** RADAR *** // palubni deska je vykreslena jako polygony s malou hloubkou

  glTranslatef(0.45,-0.30,-1.002);

  glBegin(GL_QUADS);
  glColor3f(0.3,0.6,0.9);
  glVertex3f(0.10,-0.10,-0.001);
  glVertex3f(0.10,0.10,-0.001);
  glVertex3f(-0.10,0.10,-0.001);
  glVertex3f(-0.10,-0.10,-0.001);
  glEnd;

  glRotatef(ang,0,0,1); // rotace informaci na radaru podle otoceni letounu

  // umistovani letounu
  for i:=1 to 32 do if (clientsid[i]<>0) and (inlongs[i]=0) then
  if sqrt((ks[i]-k)*(ks[i]-k)+(ms[i]-m)*(ms[i]-m))<radarzoom then begin
    glTranslatef((ks[i]-k)/(radarzoom*10),-(ms[i]-m)/(radarzoom*10),0);
    glRotatef(angs[i],0,0,-1);
    glBegin(GL_TRIANGLES);
    setColor(clientstcolor[i]);
    glVertex3f(0.000,0.005,0);
    glVertex3f(-0.003,-0.003,0);
    glVertex3f(0.003,-0.003,0);
    glEnd;
    glRotatef(angs[i],0,0,1);
    glTranslatef(-(ks[i]-k)/(radarzoom*10),(ms[i]-m)/(radarzoom*10),0);
  end;

  j:=0; while (clientsid[j]<>clientid) and (j<32) do j:=j+1; // muj index

  // umistovani strel
  for i:=1 to shcnt do if (shact[i]) and (sht[i]=1) then
  if sqrt((shx[i]-k)*(shx[i]-k)+(shz[i]-m)*(shz[i]-m))<radarzoom then begin
    glTranslatef((shx[i]-k)/(radarzoom*10),-(shz[i]-m)/(radarzoom*10),0);
    glBegin(GL_TRIANGLES);
    if j=shs[i] then
      glColor3f(random,random/5,0) else glColor3f(random/2+0.5,random/2+0.5,0);
    glVertex3f(0.0015,0.0015,0);
    glVertex3f(-0.0015,0.0015,0);
    glVertex3f(-0.0015,-0.0015,0);
    glVertex3f(0.0015,-0.0015,0);
    glEnd;
    glTranslatef(-(shx[i]-k)/(radarzoom*10),(shz[i]-m)/(radarzoom*10),0);
  end;

  // umistovani krychli
if gametype=2 then for i:=1 to spawnscnt do if teamcolor[i]<>clNone then
  if sqrt((cux[i]-k)*(cux[i]-k)+(cuz[i]-m)*(cuz[i]-m))<radarzoom then begin
    glTranslatef((cux[i]-k)/(radarzoom*10),-(cuz[i]-m)/(radarzoom*10),0.0001);
    glRotatef(cuay[i],0,0,-1);
    glBegin(GL_QUADS);
    setColor(teamcolor[i]);
    glVertex3f(0.0025,0.0025,0);
    glVertex3f(-0.0025,0.0025,0);
    glVertex3f(-0.0025,-0.0025,0);
    glVertex3f(0.0025,-0.0025,0);
    glEnd;
    glRotatef(cuay[i],0,0,1);
    glTranslatef(-(cux[i]-k)/(radarzoom*10),(cuz[i]-m)/(radarzoom*10),-0.0001);
  end;


  glRotatef(ang,0,0,-1);
  glTranslatef(-0.45,0.30,1.002); // zpetna rotace a posun (radar)

//***  ENERGY *** // zivoty

  glBegin(GL_QUADS);
  glColor3f(1-energy/energymax,energy/energymax,0.1);
  glVertex3f(-0.50,-0.40,-1.005);
  glVertex3f(-0.48,-0.40,-1.005);
  glVertex3f(-0.48,-0.40+(energy/energymax*0.20),-1.005);
  glVertex3f(-0.50,-0.40+(energy/energymax*0.20),-1.005);
  glEnd;

//*** SPEED *** // rychlost

  glBegin(GL_QUADS);
  glColor3f(0.8,0.8,0.8);
  glVertex3f(-0.432,-0.20,-1.005);
  glVertex3f(-0.448,-0.20,-1.005);
  glVertex3f(-0.448,-0.375,-1.005);
  glVertex3f(-0.432,-0.375,-1.005);
  glEnd;
  glBegin(GL_QUADS);
  glColor3f(0.8,0.5,0.5);
  glVertex3f(-0.432,-0.375,-1.005);
  glVertex3f(-0.448,-0.375,-1.005);
  glVertex3f(-0.448,-0.40,-1.005);
  glVertex3f(-0.432,-0.40,-1.005);
  glEnd;
  glBegin(GL_QUADS);
  glColor3f(0.8,0.2,0.1);
  glVertex3f(-0.455,-0.403+(speed/speedp*0.20),-1.003);
  glVertex3f(-0.425,-0.403+(speed/speedp*0.20),-1.003);
  glVertex3f(-0.425,-0.397+(speed/speedp*0.20),-1.003);
  glVertex3f(-0.455,-0.397+(speed/speedp*0.20),-1.003);
  glEnd;

//***  RELOAD *** // energie

  glBegin(GL_QUADS);
  glColor3f(0.8,0.4,0.1);
  glVertex3f(-0.40,-0.40,-1.005);
  glVertex3f(-0.38,-0.40,-1.005);
  glVertex3f(-0.38,-0.40+(mrel/mrelmax*0.20),-1.005);
  glVertex3f(-0.40,-0.40+(mrel/mrelmax*0.20),-1.005);
  glEnd;

//*** AIMS ***

for i:=1 to shcnt do if shact[i] and (shs[i]=j) then j:=100;

if j=100 then begin // jsem zameren raketou - signalizace
  glBegin(GL_QUADS);
  glColor3f(1.0,0.3,0.0);
  glVertex3f(-0.54,-0.24,-1.005);
  glVertex3f(-0.51,-0.24,-1.005);
  glVertex3f(-0.51,-0.21,-1.005);
  glVertex3f(-0.54,-0.21,-1.005);
  glEnd;
  glBegin(GL_QUADS);
  glColor3f(1.0,1.0,0.0);
  glVertex3f(-0.525,-0.245,-1.005);
  glVertex3f(-0.505,-0.225,-1.005);
  glVertex3f(-0.525,-0.205,-1.005);
  glVertex3f(-0.545,-0.225,-1.005);
  glEnd;
end;

//*** CUBES *** // informace o tom, ze nesu kostku nebo ze mi schazi

if carry>0 then begin
  glBegin(GL_QUADS);
  setColor(teamcolor[carry]);
  glVertex3f(-0.23,-0.41,-1.005);
  glVertex3f(-0.23,-0.31,-1.005);
  glVertex3f(-0.33,-0.31,-1.005);
  glVertex3f(-0.33,-0.41,-1.005);
  glEnd;
end;
i:=0; while (teamcolor[i]<>pregame.cColor.Selected) and (i<32) do i:=i+1;
  blink:=blink+tim.Interval;if blink>500 then blink:=0;
if ((cux[i]<>cuxb[i]) or (cuy[i]<>cuyb[i]) or (cuz[i]<>cuzb[i]) or
(cuowner[i]>0)) and (blink<250) then begin
  glBegin(GL_QUADS);
  setColor(teamcolor[i]);
  glVertex3f(0.23,-0.31,-1.005);
  glVertex3f(0.23,-0.41,-1.005);
  glVertex3f(0.33,-0.41,-1.005);
  glVertex3f(0.33,-0.31,-1.005);
  glEnd;
end;

//*** DOT *** // zamerovaci tecka uprostred obrazu
  glBegin(GL_QUADS);
  glColor3f(0.9,0.9,0.0);
  glVertex3f(0.002,0.002,-1);
  glVertex3f(-0.002,0.002,-1);
  glVertex3f(-0.002,-0.002,-1);
  glVertex3f(0.002,-0.002,-1);
  glEnd;
if view=1 then begin // pohled zezadu
  glTranslatef(0,-1,-5);
end else begin // pohled zevnitr, vykreslovani palubni desky
//*** COCKPIT ***
  glBegin(GL_QUADS);
  setColor(pregame.cColor.Selected);
  glVertex3f(-1,0.5,-1.01);
  glVertex3f(-1,0.405,-1.01);
  glVertex3f(1,0.405,-1.01);
  glVertex3f(1,0.5,-1.01);
  glEnd;
  glBegin(GL_QUADS);
  glColor3f(0.6,0.6,0.6);
  glVertex3f(-0.34,-0.29,-1.01);
  glVertex3f(-0.34,-0.30,-1.01);
  glVertex3f(0.34,-0.30,-1.01);
  glVertex3f(0.34,-0.29,-1.01);
  glEnd;

  glBegin(GL_QUADS);
  glColor3f(0.6,0.6,0.6);
  glVertex3f(-0.34,-0.30,-1.01);
  glVertex3f(-0.34,-0.19,-1.01);
  glVertex3f(-0.35,-0.19,-1.01);
  glVertex3f(-0.35,-0.30,-1.01);
  glEnd;
  glBegin(GL_QUADS);
  glColor3f(0.6,0.6,0.6);
  glVertex3f(-0.35,-0.20,-1.01);
  glVertex3f(-0.35,-0.19,-1.01);
  glVertex3f(-1,-0.19,-1.01);
  glVertex3f(-1,-0.20,-1.01);
  glEnd;
  glBegin(GL_QUADS);
  glColor3f(0.4,0.4,0.4);
  glVertex3f(-0.35,-0.30,-1.01);
  glVertex3f(-0.35,-0.20,-1.01);
  glVertex3f(-1,-0.20,-1.01);
  glVertex3f(-1,-0.30,-1.01);
  glEnd;

  glBegin(GL_QUADS);
  glColor3f(0.6,0.6,0.6);
  glVertex3f(0.34,-0.19,-1.01);
  glVertex3f(0.34,-0.30,-1.01);
  glVertex3f(0.35,-0.30,-1.01);
  glVertex3f(0.35,-0.19,-1.01);
  glEnd;
  glBegin(GL_QUADS);
  glColor3f(0.6,0.6,0.6);
  glVertex3f(0.35,-0.19,-1.01);
  glVertex3f(0.35,-0.20,-1.01);
  glVertex3f(1,-0.20,-1.01);
  glVertex3f(1,-0.19,-1.01);
  glEnd;
  glBegin(GL_QUADS);
  glColor3f(0.4,0.4,0.4);
  glVertex3f(0.35,-0.20,-1.01);
  glVertex3f(0.35,-0.30,-1.01);
  glVertex3f(1,-0.30,-1.01);
  glVertex3f(1,-0.20,-1.01);
  glEnd;

  glBegin(GL_QUADS);
  glColor3f(0.4,0.4,0.4);
  glVertex3f(-1,-0.30,-1.01);
  glVertex3f(-1,-0.5,-1.01);
  glVertex3f(1,-0.5,-1.01);
  glVertex3f(1,-0.30,-1.01);
  glEnd;
end;
//*** BURN ***

if not cleanresp and (inactlong>0) and (view=0) then // shoreni letounu
for i:=1 to 12-round(12*(inactlong/inactlongmax)) do begin
  temp1:=random*1.4-0.5;temp2:=random*0.2;temp3:=random*1.2;tempc:=random;
  glBegin(GL_TRIANGLES); // nahodne trojuhelniky teplych barev
  glColor3f(0.8,tempc,0);
  glVertex3f(temp1,-0.5+temp3,-1.0);
  glColor3f(0.8,tempc,0);
  glVertex3f(temp1-temp2,-0.5,-1.0);
  glColor3f(0.8,tempc,0);
  glVertex3f(temp1+temp2,-0.5,-1.0);
  glEnd;
end;

//*** WORLD *** // vykreslovani sveta

  glScalef(0.5,0.5,0.5);

  glRotatef(angr,0.0,0.0,1.0); // natoceni podle rotace letounu
  glRotatef(angh,1.0,0.0,0.0);
  glRotatef(ang,0.0,1.0,0.0);

  for i:=1 to shcnt do if shact[i] then // strely
    if sht[i]=0 then putshot(i) else putrocket(i);

  if gametype=2 then for i:=1 to spawnscnt do // krychle
  if (cuowner[i]=0) and (teamcolor[i]<>clNone) then putcube(i,1);

  j:=0;
  for i:=1 to 32 do begin // cizi letouny
  if (clientsid[i]<>clientid) and (clientsid[i]<>0) then
  putplane(ks[i],ls[i],ms[i],anghs[i],angs[i],angrs[i],i);
  if (clientsid[i]=clientid) then j:=i;
  end;

  if view=1 then putplane(k,l,m,angh,ang,angr,j); // vlastni zezadu

  for i:=1 to polycnt do begin // polygony sveta
  case polypoints[i] of
  3:glBegin(GL_TRIANGLES);
  4:glBegin(GL_QUADS);
  else
  glBegin(GL_POLYGON);
  end;
    for j:=1 to polypoints[i] do begin

    glColor3f(polyr[i,j],polyg[i,j],polyb[i,j]);
    putpoint(polyx[i,j],polyy[i,j],polyz[i,j]);
    end;
  glEnd;
  end;

end;

// ******************* DRAW *****************
procedure Tuniverse.putpoint(x,y,z:double);
begin
glVertex3f(x-k,y-l,z-m);
end;

procedure Tuniverse.putplane(x,y,z,xang,yang,zang:double;planei:integer);
var i,j:integer;
begin

glTranslatef(x-k,y-l,z-m);

glRotatef(yang,0.0,-1.0,0.0); // rotace letounu
glRotatef(xang,-1.0,0.0,0.0);
glRotatef(zang,0.0,0.0,-1.0);

  for i:=512 to planepolycnt do begin // umisteni polygonu
  case polypoints[i] of
  3:glBegin(GL_TRIANGLES);
  4:glBegin(GL_QUADS);
  else
  glBegin(GL_POLYGON);
  end;
    for j:=1 to polypoints[i] do
    if (inlongs[planei]=0) or (inlongs[planei]/inactlongmax>random) then
    begin
    
    if (polyr[i,j]=3) and (polyg[i,j]=3) and (polyb[i,j]=3) then
    setColor(clientstcolor[planei]) else // vyber spravne barvy
    if (polyr[i,j]=2) and (polyg[i,j]=2) and (polyb[i,j]=2) then
    setColor(clientscolor[planei]) else
    glColor3f(polyr[i,j],polyg[i,j],polyb[i,j]);

    glVertex3f(polyx[i,j],polyy[i,j],polyz[i,j]);
    
    end;
  glEnd;
  end;

if carrys[planei]>0 then begin // krychle za letounem
glTranslatef(0,0,3);
putcube(carrys[planei],0);
glTranslatef(0,0,-3);
end;

glRotatef(zang,0.0,0.0,1.0);
glRotatef(xang,1.0,0.0,0.0);
glRotatef(yang,0.0,1.0,0.0);

glTranslatef(k-x,l-y,m-z);

end;

procedure Tuniverse.planecrash; // zvuk vybuchu
begin
sndplay('crash.wav',12,10);
end;

procedure Tuniverse.putshot(shoti:integer);
var i,j:integer;
begin
// umisteni strel - podobne jako umisteni letadla

glTranslatef(shx[shoti]-k,shy[shoti]-l,shz[shoti]-m);

glRotatef(shay[shoti],0.0,-1.0,0.0);
glRotatef(shax[shoti],-1.0,0.0,0.0);
glRotatef(shaz[shoti],0.0,0.0,-1.0);

  for i:=768 to shotpolycnt do begin
  case polypoints[i] of
  3:glBegin(GL_TRIANGLES);
  4:glBegin(GL_QUADS);
  else
  glBegin(GL_POLYGON);
  end;
    for j:=1 to polypoints[i] do begin
    glColor3f(polyr[i,j],polyg[i,j],polyb[i,j]);
    glVertex3f(polyx[i,j],polyy[i,j],polyz[i,j]);
    end;
  glEnd;
  end;

glRotatef(shaz[shoti],0.0,0.0,1.0);
glRotatef(shax[shoti],1.0,0.0,0.0);
glRotatef(shay[shoti],0.0,1.0,0.0);

glTranslatef(k-shx[shoti],l-shy[shoti],m-shz[shoti]);

end;

procedure Tuniverse.putrocket(shoti:integer);
var i,j:integer;
begin

glTranslatef(shx[shoti]-k,shy[shoti]-l,shz[shoti]-m);

glRotatef(shay[shoti],0.0,-1.0,0.0);
glRotatef(shax[shoti],-1.0,0.0,0.0);
glRotatef(shaz[shoti],0.0,0.0,-1.0);

  for i:=832 to rocketpolycnt do begin
  case polypoints[i] of
  3:glBegin(GL_TRIANGLES);
  4:glBegin(GL_QUADS);
  else
  glBegin(GL_POLYGON);
  end;
    for j:=1 to polypoints[i] do begin
    glColor3f(polyr[i,j],polyg[i,j],polyb[i,j]);
    glVertex3f(polyx[i,j],polyy[i,j],polyz[i,j]);
    end;
  glEnd;
  end;

glRotatef(shaz[shoti],0.0,0.0,1.0);
glRotatef(shax[shoti],1.0,0.0,0.0);
glRotatef(shay[shoti],0.0,1.0,0.0);

glTranslatef(k-shx[shoti],l-shy[shoti],m-shz[shoti]);

end;

procedure Tuniverse.putcube(cubei:integer;freecube:integer);
var i,j:integer;
begin

if freecube=1 then begin // krychle si rotuje u sebe
glTranslatef(cux[cubei]-k,cuy[cubei]-l,cuz[cubei]-m);

glRotatef(cuay[cubei],0.0,-1.0,0.0);
glRotatef(cuax[cubei],-1.0,0.0,0.0);
glRotatef(cuaz[cubei],0.0,0.0,-1.0);
end;

  for i:=896 to cubepolycnt do begin
  case polypoints[i] of
  3:glBegin(GL_TRIANGLES);
  4:glBegin(GL_QUADS);
  else
  glBegin(GL_POLYGON);
  end;
    for j:=1 to polypoints[i] do begin
    if polyr[i,j]=2 then
    setColor(teamcolor[cubei]);
    if polyr[i,j]=3 then
    glColor3f(((colortorgb(teamcolor[cubei]) mod 256)/255+0.5)/2,
    ((colortorgb((teamcolor[cubei]) div 256) mod 256)/255+0.5)/2,
    (colortorgb((teamcolor[cubei]) div 65536)/255+0.5)/2
    );
    glVertex3f(polyx[i,j],polyy[i,j],polyz[i,j]);
    end;
  glEnd;
  end;

if freecube=1 then begin // zpetna rotace a posun
glRotatef(cuaz[cubei],0.0,0.0,1.0);
glRotatef(cuax[cubei],1.0,0.0,0.0);
glRotatef(cuay[cubei],0.0,1.0,0.0);

glTranslatef(k-cux[cubei],l-cuy[cubei],m-cuz[cubei]);
end;

end;

procedure Tuniverse.FormKeyPress(Sender: TObject; var Key: Char);
begin
if key=chr(27) then begin frozen:=true;universe.Close; end; // preruseni hry
end;

procedure Tuniverse.FormShow(Sender: TObject); // obnoveni sceny po preruseni
var i:integer;
begin
for i:=1 to 32 do
  if (clientsid[i]=clientid) then inactlong:=(i-1)*16*round(tim.Interval);

pregame.bShow.Enabled:=false;
activ:=false;
frozen:=false;
cleanresp:=true;

end;

// ************* SETDATA **************
procedure Tuniverse.setdata(msg:string); // nacte informace podle prijatych dat
var
number:string;
varia:char;
theid,ptr,i,j:integer;
readno:boolean;
begin

varia:=' ';
theid:=strtoint(Copy(msg,4,8)); // na zacatku je ID odesilatele
ptr:=0;
for j:=1 to 32 do if clientsid[j]=theid then begin ptr:=j; break; end;
msg:=Copy(msg,12,length(msg)-11); // zbytek je zprava
readno:=false;
number:='';
i:=0;

while msg[i]<>'#' do begin // zprava konci #
i:=i+1;
if readno=false then begin
varia:=msg[i];
readno:=true;
end else
  begin
    if (msg[i]<>'`') and (msg[i]<>'#') then number:=number+msg[i]
    else begin
case varia of // ridici znaky rozhodnou o vyuziti informace
'n':inlongs[ptr]:=strtofloat(number);
'f':carrys[ptr]:=strtoint(number);
'k':ks[ptr]:=strtofloat(number);
'l':ls[ptr]:=strtofloat(number);
'm':ms[ptr]:=strtofloat(number);
'a':kps[ptr]:=strtofloat(number);
'b':lps[ptr]:=strtofloat(number);
'c':mps[ptr]:=strtofloat(number);
'u':angs[ptr]:=strtofloat(number);
'h':anghs[ptr]:=strtofloat(number);
'r':angrs[ptr]:=strtofloat(number);
end;
if carrys[ptr]>0 then cuowner[carrys[ptr]]:=ptr;
  // priradi si do tabulky informaci o tom, jakou hrac nese krychli 
number:='';
readno:=false;
    end;
  end;
end;

end;

procedure Tuniverse.FormClose(Sender: TObject; var Action: TCloseAction);
begin
clientdatatext:=clientdatatext+'dat'+inttostr(clientid)+'k1000`l-1000`m1000#';
if winid=0 then begin // skryti okna, umozneni otevreni
pregame.bShow.Enabled:=True;
pregame.bShow.Default:=true;
end else // pokud uz se skoncilo, server resetuje hru
begin
if pregame.bServer.Caption='Cancel' then datatext:=datatext+'new00000000#';
end;

frozen:=true;
end;

procedure TUniverse.setColor(theColor:TColor); // nastaveni barvy pro OpenGL
begin
glColor3f(((colortorgb(theColor) mod 256)/255),
((colortorgb(theColor) div 256) mod 256)/255,
((colortorgb(theColor) div 65536)/255)
);
end;

procedure Tuniverse.FormCreate(Sender: TObject);
begin
world.Cursor:=crNone; // schova mys
info.Cursor:=crNone;
end;

end.

